;
;	MZ LPT <--> PC FT245RL Bridge
;
;	RB[7]	RD#	(-> FT245RL)
;	RB[6]	WR	(-> FT245RL)
;	RB[5]	TXE#	(<- FT245RL)
;	RB[4]	RXF#	(<- FT245RL)
;	RB[3]	RDP	(<- MZ)
;	RB[2]	IRT	(<- MZ)
;	RB[1]	RDA	(-> MZ)
;	RB[0]	STA	(-> MZ)
;
;	RA[4]	MZ LPT Tristate Gate Open
;	RA[3:0]	FT245RL Data Bus[3:0]
;

;	PCɑMR}h:
;		0 = (reserved)
;		1 = SAVE
;		2 = LOAD

	LIST   P=PIC16F648A
	INCLUDE	<P16F648A.INC>

	__CONFIG _BODEN_ON & _HS_OSC & _WDT_OFF & _PWRTE_ON & _MCLRE_ON & _LVP_OFF

ifz	macro
	btfsc	STATUS, Z
	endm

ifnz	macro
	btfss	STATUS, Z
	endm

if1	macro	fr1, fr2
	btfsc	fr1, fr2
	endm

if0	macro	fr1, fr2
	btfss	fr1, fr2
	endm

;
;	FT2451oCgM
;
read_FT245 macro
	bcf	PORTB, FT245_RD		; RDLow
	movf	PORTA, W		; FT245ǂ
	bsf	PORTB, FT245_RD		; RDHigh
	endm

CMD_RESP	EQU	H'10'		; PC̃R}h0ɑ΂郌X|X
CMD_SAVE	EQU	H'11'		; MZ̓]Jn
CMD_LOAD	EQU	H'12'		; MZ֑f[^1pPbgv
CMD_DISCON	EQU	H'1F'		; PC̃R}h0ɑ΂郌X|X ڑĂȂ

FT245_RD	EQU	H'07'
FT245_WR	EQU	H'06'
FT245_TXE	EQU	H'05'
FT245_RXF	EQU	H'04'

MZ_RDP		EQU	H'03'
MZ_IRT		EQU	H'02'
MZ_RDA		EQU	H'01'
MZ_STA		EQU	H'00'

LS244G		EQU	H'04'

TMP0		EQU	H'20'
TMP1		EQU	H'21'
TMP2		EQU	H'22'

RXCOUNT		EQU	H'24'		; pPbgM̎coCg
RDATA		EQU	H'25'		; MZ֑M̃f[^
;RXRESP		EQU	H'26'

;
;	
;
	bcf	STATUS, RP0		; Bank 0
	movlw	B'00000111'		;
	movwf	CMCON			; Rp[^OFF
	movlw	H'10'			; GATE=H
	movwf	PORTA			; Init PORTA
	movlw	H'82'			; RD#=H, RDA=H
	movwf	PORTB			; Init PORTB
	bsf	STATUS, RP0		; Bank 1
	movlw	H'0F'			; |[gA[3:0]͂ɐݒ
	movwf	TRISA			;
	movlw	H'3C'			; |[gB[5:2]͂ɐݒ
	movwf	TRISB			;
	bcf	OPTION_REG, NOT_RBPU	; |[gB̃vAbvLɂ

	bcf	STATUS,RP0		; Bank 0

;---------------------------------------;
;	ҋ@			;
;---------------------------------------;
idle:
	movlw	H'82'			; RD#=H, RDA=H
	movwf	PORTB
idle0:
	movf	PORTB, W		; MZ̐MĤƂ
	andlw	H'0C'			; ԂڑĂȂ̂ŁA
	xorlw	H'0C'
	ifz
	goto	idle1

	if1	PORTB, MZ_IRT		; IRTHɂȂH
	goto	receive			; LOAD from PC
	if1	PORTB, MZ_RDP		; RDPHɂȂH
	goto	send			; SEND to PC
idle1:
	if1	PORTB, FT245_RXF	; PCȂɂĂH
	goto	idle0
	read_FT245
	andlw	H'0F'			; ZbgR}hH
	ifnz
	goto	idle0			; ZbgȊOȂǂݎ̂Ă邾
	movlw	CMD_RESP
	if0	PORTB, MZ_IRT
	goto	idle2
	if1	PORTB, MZ_RDP
	movlw	CMD_DISCON
idle2:	call	command_FT245		; X|X𑗂
	goto	idle0

;---------------------------------------;
;	MZ  PC M			;
;---------------------------------------;
send:
	call	wait500ms		; Ƒ҂ĂxRDP`FbN
	if0	PORTB, MZ_RDP		; RDPHH
	goto	idle
	if1	PORTB, MZ_IRT		; IRTLH
	goto	idle

	movlw	CMD_SAVE		; 1: SAVE command
	call	command_FT245
send0:
	bsf	PORTB, MZ_RDA		; RDA = H ɂMZɑMOK`
send1:	if0	PORTB, FT245_RXF
	goto	idle
	if0	PORTB, MZ_RDP		; RDP == H ҂
	goto	send1

send2:	if0	PORTB, FT245_RXF
	goto	idle
	if1	PORTB, FT245_TXE	; FT245ɑMł悤ɂȂ܂ő҂
	goto	send2

	bcf	PORTA, LS244G		; MZ->FT245 
	bsf	PORTB, FT245_WR
	bcf	PORTB, FT245_WR
	bsf	PORTA, LS244G
	bcf	PORTB, MZ_RDA		; RDA = L ɂ

send3:	if0	PORTB, FT245_RXF
	goto	idle
	if1	PORTB, MZ_RDP		; RDP == L ҂
	goto	send3
	goto	send0

;---------------------------------------;
;	MZ  PC M			;
;---------------------------------------;
receive:
	call	wait500ms		; Ƒ҂ĂxIRT`FbN
	if0	PORTB, MZ_IRT		; IRTHH
	goto	idle
	if1	PORTB, MZ_RDP		; RDPLH
	goto	idle

	movlw	CMD_LOAD
	call	command_FT245		; PCɃf[^v

;	clrf	RXRESP

recv_siz0:				; MJEg
	if1	PORTB, FT245_RXF
	goto	recv_siz0
	read_FT245
	andlw	H'0F'
	movwf	RXCOUNT
	swapf	RXCOUNT, F
recv_siz1:
	if1	PORTB, FT245_RXF
	goto	recv_siz1
	read_FT245
	andlw	H'0F'
	iorwf	RXCOUNT, F
	if1	RXCOUNT, H'00'		; JEgȂAI
	goto	idle

recv0:
	if1	PORTB, FT245_RXF	; FT2451juM
	goto	recv0
	read_FT245
	movwf	RDATA
recv1:
	movlw	H'80'			; RDA=Low
	if1	RDATA, H'03'		; if (Bit 3 == 1) then STA = 1
	iorlw	H'01'
	movwf	PORTB			; RDA=Low, STA=DATA
recv2:
	if0	PORTB, MZ_RDP		; RDP == H ҂
	goto	recv2

	movlw	H'82'			; RDA=High
	if1	RDATA, H'02'		; if (Bit 2 == 1) then STA = 1
	iorlw	H'01'
	movwf	PORTB			; RDA=High, STA=DATA
recv4:
	if1	PORTB, MZ_RDP		; RDP == L ҂
	goto	recv4

	movlw	H'80'			; RDA=Low
	if1	RDATA, H'01'		; if (Bit 1 == 1) then STA = 1
	iorlw	H'01'
	movwf	PORTB			; RDA=Low, STA=DATA
recv6:
	if0	PORTB, MZ_RDP		; RDP == H ҂
	goto	recv6

	movlw	H'82'			; RDA=High
	if1	RDATA, H'00'		; if (Bit 0 == 1) then STA = 1
	iorlw	H'01'
	movwf	PORTB			; RDA=High, STA=DATA
recv8:
	if1	PORTB, MZ_RDP		; RDP == L ҂
	goto	recv8

	decfsz	RXCOUNT, F
	goto	recv0

;	movf	RXRESP, W
;	iorlw	H'F0'
;	call	command_FT245
;	incf	RXRESP, F

	goto	recv_siz0

;
;	FT245ɃR}h(Fx)𑗐M
;
command_FT245:				;IN: W[3:0] = command code
	movwf	PORTA
command0:
	if1	PORTB, FT245_TXE
	goto	command0
command1:
	bsf	STATUS, RP0		; Bank 1
	clrf	TRISA			; |[gA[4:0]o͂ɐݒ
	bcf	STATUS, RP0		; Bank 0
	bsf	PORTB, FT245_WR
	bcf	PORTB, FT245_WR		; FT245WRpX𑗂
	bsf	STATUS, RP0		; Bank 1
	movlw	H'0F'			; |[gA[3:0]͂ɐݒ
	movwf	TRISA			;
	bcf	STATUS, RP0		; Bank 0
	return

;
;	500msEFCg
;
wait500ms:
	movlw	H'0A'			; 10
	movwf	TMP2
wait2:	call	wait50ms
	decfsz	TMP2, F
	goto	wait2
	return
;
;	50msEFCg
;
wait50ms:
	movlw	H'C8'			; 200
	movwf	TMP1
wait1:	movlw	H'FA'			; 250
	movwf	TMP0
wait0:	nop
	nop
	decfsz	TMP0, F			; 1us
	goto	wait0
	decfsz	TMP1, F			; 50ms
	goto	wait1
	return

	END

;   [MZ]		[PC]
;    RDP	-->	SLCT
;    D0-D7	-->	D0-D7
;    IRT	-->	PE
;    RDA	<--	STB
;    STA	<--	AUTOFXINIT
;
;MZ <- PC
;	1. IRT=H ɂ		IRTRDPH ɂȂ Load command
;	2. RDA=L ҂
;	3. STAǂݍ
;	4. RDP=H ɂ
;	5. RDA=H ҂
;	6. STAǂݍ
;	7. RDP=L ɂ
;	8. 2ɖ߂
;
;MZ -> PC			RDPIRTH ɂȂ Save command
;	1. RDA=H ҂
;	2. Data
;	3. RDP=H ɂ
;	4. RDA=L ҂
;	5. RDP=L ɂ
;	6. 1ɖ߂
